#pragma once

#include <SDL2/SDL.h>
#include <ceev/colors.h>
#include <ceev/lang.h>
#include <unistd.h>
#include <algorithm>
#include <cstdlib>
#include <cstring>
#include <deque>
#include <filesystem>
#include <fstream>
#include <iostream>
#include <sstream>

#ifndef __ceev_version
#define __ceev_version "0.1.1-devel"
#endif

#ifndef CONFIG_FILENAME
#define CONFIG_FILENAME "ceev.cfg"
#endif

#ifndef GIT_COMMIT_HASH
#define GIT_COMMIT_HASH "Unknown"
#endif

#ifndef GIT_COMMIT_MSG
#define GIT_COMMIT_MSG "Unknown"
#endif

#ifndef GIT_COMMIT_DATE
#define GIT_COMMIT_DATE "Unknown"
#endif

#ifndef GIT_COMMIT_AUTHOR
#define GIT_COMMIT_AUTHOR "Unknown"
#endif

#undef GET_PROGRAM_NAME
#ifdef __GLIBC__
#define GET_PROGRAM_NAME() program_invocation_short_name
#else
#define GET_PROGRAM_NAME() getprogname()
#endif

#define INPROG bg_bright_green("INPROG")
#define TODO bg_yellow(green("TODO"))
#define HALTED bg_red(white("HALTED"))
#define STATUS bg_green(bold("STATUS"))

#define WIP std::cout << TODO << ": Function is a work in progress" << std::endl
#define NYI \
    std::cout << TODO << ": Function is not yet implemented" << std::endl

bool CV_ISDEBUG = false;

namespace fs = std::filesystem;

struct config_data {
    std::string name = "";
    std::string version = "";
    std::string author = "";
    std::string email = "";
};
static int usage();
static int show_help();
static int buildinfo();
bool replace(std::string& str, const std::string& from, const std::string& to);
struct config_data get_config(bool ignore_err);
int create_fs(std::deque<std::string> args);
int build_project(std::deque<std::string> args);
int run_project(std::deque<std::string> args);
int clean_project(std::deque<std::string> args);
int devel(std::deque<std::string> args);
int devel_help();
int devel_roadmap();
int devel_sdl2(std::deque<std::string> args);
int devel_lang(std::deque<std::string> args);
int main(int argc, char** argv);
